// --------------------------------------------------------------------
//  Common Controls 

#include <windows>
#include "winlib.h"
#include "common.h"

class _CommonInitalize{
	public:
	  _CommonInitalize(){ InitCommonControls() ; } ;
	  ~_CommonInitalize(){} ;
} ;

_CommonInitalize _CommonControlInitalize ;

// --------------------------------------------------------------------
// class StatusBar Methods
//

void StatusBar::Initalize(FrameWnd *Parent,int PartNumb)
{
	int i ;
	ParentWnd=Parent ;
	Style=WS_CHILD|SBARS_SIZEGRIP|CCS_BOTTOM|WS_VISIBLE ;
	if(PartNumb>=STATUSBAR_PARTITION_MAX) PartNumb=STATUSBAR_PARTITION_MAX ;
	if(PartNumb<1) PartNumb=0 ; // SIMPLE
	Parts=PartNumb ;  // Parts==1łSimpleɂ͂ȂB
	for(i=0 ; i<STATUSBAR_PARTITION_MAX ; i++) PartSize[i]=32 ;
	// ftHgĺAP؂łRQhbg
	UsingRate=UsingFixedEnd=FALSE ;
	SBP_Set=FALSE ;
}

int  StatusBar::FlexPos(void)
{
	int i ;
	for(i=0 ; i<Parts ; i++) if(PartSize[i]==SBW_FLEXIBLE) return(i) ;
	return(-1) ;
}

HWND StatusBar::Create(void)
{
	BaseWnd::Create(CreateStatusWindow(*Style,NULL,
	             ParentWnd->GetHandle(),(UINT)MenuMsgID->GetID())) ;
	return(BaseWnd::handleWnd) ;
}

void StatusBar::DefineWidth(int PartPos,int Width)
{
	int i,flx ;
	if(PartPos<0) return ;
	if(PartPos>Parts) return ;
	flx=FlexPos() ;
	if(Width==SBW_FLEXIBLE){
	  if(flx==-1){ // FLEXʒúAPĴݎw
	    PartSize[PartPos]=Width ;
	  }
	}
	else PartSize[PartPos]=Width ;
}

void StatusBar::FitSize(WPARAM wp,LPARAM lp,int PartNumb,int *Pos)
{
	SendMessage(SB_SETPARTS,(WPARAM)PartNumb,(LPARAM)Pos) ;
	SendMessage(WM_SIZE,wp,lp) ;
}

void StatusBar::FitSize(WPARAM wp,LPARAM lp) 
{
	int i,flx,SBSbuff[STATUSBAR_PARTITION_MAX] ;
	int fxend,tsize,fxwidth ;
	fxend=LOWORD(lp) ;
	if(Parts){  // Simple(Parts==0)̏ꍇ́AsȂ
	  if(UsingRate){
	    SizeRate->GetVal(PartSize,(long)fxend) ;
	    if(UsingFixedEnd) PartSize[Parts-1]=SBW_FLEXIBLE ;
	  }
	  flx=FlexPos() ;
	  if(flx!=-1){
	    tsize=0 ;
	    for(i=0 ; i<Parts ; i++){ // flexSZ
	      if(i!=flx) tsize+=PartSize[i] ;
	    }
	    fxwidth=fxend-tsize ; // cflexwidthƂB
	    if(fxwidth<0) fxwidth=0 ;
	  }
	  tsize=0 ;
	  for(i=0 ; i<Parts ; i++){
	    if(i==flx){
	      if(i==Parts-1)  SBSbuff[i]=fxend ;
	      else{
	        tsize=SBSbuff[i]=fxwidth+tsize ;
	      }
	    }
	    else{
	      tsize=SBSbuff[i]=PartSize[i]+tsize ;
	    }
	  }
	  SendMessage(SB_SETPARTS,(WPARAM)Parts,(LPARAM)SBSbuff) ;
	}
	SendMessage(WM_SIZE,wp,lp) ;
}

void StatusBar::SetWindowText(char *Msg) // PZNVւ̕\
{
	if(!Parts) SendMessage(SB_SETTEXT,(WPARAM)0xff,(LPARAM)Msg) ;
	else       SendMessage(SB_SETTEXT,(WPARAM)0x00,(LPARAM)Msg) ;
}

void StatusBar::SBPrintf(char *form,...)
{
	va_list ap ;
	char msgbf[4096] ;
	va_start(ap,form) ;
	wvsprintf(msgbf,form,ap) ;
	va_end(ap) ;
	if(SBP_Set) SetWindowText(SBP_Pos,msgbf,SBP_PopUp) ;
	else SetWindowText(msgbf) ;
}

void StatusBar::SetWindowText(int PartPos,char *Message,BOOL isPopUp)
{
	int TxtStyle,PopUp ;
	if(PartPos<0) return ;
	if(Parts<=PartPos) return ;
	if(!Parts) PartPos=0xff ;
	PopUp=0 ;
	if(isPopUp) PopUp=SBT_POPOUT ;// SBT_POPOUT512=0x200
	TxtStyle=(PartPos|PopUp) ;
	SendMessage(SB_SETTEXT,(WPARAM)TxtStyle,(LPARAM)Message) ;
}

// --------------------------------------------------------------------
// class ToolBar Methods
//

// --------------------------------------------------------------------
// {^쐬邾̃NX([J)

class TBBtn{
	private:
	  TBBUTTON TB_Btn ;
	  BaseWnd *BaseBar ;
	  EventMenuID *MenuMsgID ;
	public:
	  TBBtn(BaseWnd *BTB){ BaseBar=BTB ; }
	  ~TBBtn(){} ;
	  UINT Create(int iBtnID,DWORD dwData=0,int iString=0,int MenuID=-1) ;
	  UINT Insert(int Index,int iBtnID,DWORD dwData=0,int iS=0,int MenuID=-1) ;
	  void Spacer(int Index) ;
} ;

UINT TBBtn::Create(int iBtnID,DWORD dwData,int iString,int MenuID)
{
	MenuMsgID=new EventMenuID((HMENU)MenuID) ;
	MenuID=(int)MenuMsgID->GetID() ;
	delete MenuMsgID ;
	TB_Btn.iBitmap=iBtnID ;
	TB_Btn.idCommand=MenuID ;
	TB_Btn.fsState=TBSTATE_ENABLED ; 
	TB_Btn.fsStyle=TBSTYLE_BUTTON ; 
	TB_Btn.dwData=dwData ; 
	TB_Btn.iString=iString ; 
	BaseBar->SendMessage(TB_ADDBUTTONS,1,(LONG)&TB_Btn) ;
	BaseBar->SendMessage(TB_AUTOSIZE,0,0) ;
	return((UINT)MenuID) ;
}

UINT TBBtn::Insert(int Index,int iBtnID,DWORD dwData,int iS,int MenuID)
{
	MenuMsgID=new EventMenuID((HMENU)MenuID) ;
	MenuID=(int)MenuMsgID->GetID() ;
	delete MenuMsgID ;
	TB_Btn.iBitmap=iBtnID ;
	TB_Btn.idCommand=MenuID ;
	TB_Btn.fsState=TBSTATE_ENABLED ; 
	TB_Btn.fsStyle=TBSTYLE_BUTTON ; 
	TB_Btn.dwData=dwData ; 
	TB_Btn.iString=iS ; 
	BaseBar->SendMessage(TB_INSERTBUTTON,Index,(LONG)&TB_Btn) ;
	BaseBar->SendMessage(TB_AUTOSIZE,0,0) ;
	return((UINT)MenuID) ;
}

void TBBtn::Spacer(int Index)
{
	TB_Btn.iBitmap=0 ;
	TB_Btn.idCommand=0 ;
	TB_Btn.fsState=TBSTATE_ENABLED ;
	TB_Btn.fsStyle=TBSTYLE_SEP ;
	TB_Btn.dwData=0 ;
	TB_Btn.iString=0 ;
	BaseBar->SendMessage(TB_INSERTBUTTON,Index,(LPARAM)&TB_Btn) ;
}

// ------------------------------------------------------------------
// class ToolBar Methods

void ToolBar::Initalize(FrameWnd *Parent)
{
	int i ;
	ParentWnd=Parent ;
	Style=WS_CHILD | WS_VISIBLE ;
	for(i=0 ; i<5 ; i++) BMPOFFS[i]=-1 ;
	CurrentType=TOOLBAR_TYPE_STD ;
	CurrentUIDType=IDB_STD_SMALL_COLOR ;
}

HWND ToolBar::Create(void)//̃c[o[𑢂
{
	TBBUTTON tBtn ;
	if(BaseWnd::handleWnd!=NULL) return(BaseWnd::handleWnd) ;
	BaseWnd::Create(CreateToolbarEx(
	             ParentWnd->GetHandle(),
	             *Style,
	             (UINT)MenuMsgID->GetID(),
	             0, // {^C[W
	             NULL, // BITMAP INSTANCE 
	             NULL, // BITMAP RESOURCE ID
	             &tBtn,
	             0,  // {^
	             0,0,0,0,
	             sizeof(TBBUTTON))) ;
	return(BaseWnd::handleWnd) ;
}

HWND ToolBar::Create(TBBUTTON *tbb,int bmpnumb,int bmpid,
      int btnnumb,int bwid,int bhit)
{
	if(BaseWnd::handleWnd!=NULL) return(BaseWnd::handleWnd) ;
	BaseWnd::Create(CreateToolbarEx(
	             ParentWnd->GetHandle(),
	             *Style,
	             (UINT)MenuMsgID->GetID(),
	             bmpnumb, // {^C[W
	             GetInstance(), // USEȐꍇAṽCX^X
	             bmpid, // BITMAP RESOURCE ID
	             tbb, //{^`
	             btnnumb,  // {^
	             0,0,
	             bwid,bhit,
	             sizeof(TBBUTTON))) ;
	return(BaseWnd::handleWnd) ;
}

BOOL ToolBar::LoadBitmap(int BmpType,HINSTANCE hiBmp,UINT nID,int BMNumb)
{
	TBADDBITMAP tbadd ;
	int startid ;
	if(BmpType<0 || BmpType>TOOLBAR_TYPE_USER) return FALSE;
	tbadd.hInst=hiBmp ;
	tbadd.nID=nID ;
	startid=SendMessage(TB_ADDBITMAP,BMNumb,(LPARAM)&tbadd) ;
	if(startid==-1) return(FALSE) ;
	BMPOFFS[BmpType]=startid ;
	return(TRUE) ;
}

void ToolBar::SetBitmapType(int BmpType,UINT nID)
{
	if(BmpType<0 || BmpType>TOOLBAR_TYPE_USER) return ;
	CurrentType=BmpType ;
	CurrentUIDType=nID ;
}

BOOL ToolBar::LoadBitmap(int BMNumb)
{
	if(CurrentType==TOOLBAR_TYPE_USER){
	  return(LoadBitmap(CurrentType,GetInstance(),CurrentUIDType,BMNumb)) ;
	}
	else{
	  return(LoadBitmap(CurrentType,HINST_COMMCTRL,CurrentUIDType,BMNumb)) ;
	}
}

UINT ToolBar::AddButton(int BmpType,int iBitmap,int idCommand)
{
	int startid ;
	TBBtn Btn(this) ;
	if(startid<0) return(0) ;
	if(BmpType<0 || BmpType>TOOLBAR_TYPE_USER) return(0) ;
	startid=BMPOFFS[BmpType] ;
	return(Btn.Create(startid+iBitmap,idCommand)) ;
}

UINT ToolBar::AddButton(int iBitmap)
{
	return(AddButton(CurrentType,iBitmap,-1)) ;
}

UINT ToolBar::InsertButton(int Index,int BmpType,int iBitmap,int idCommand)
{
	int startid ;
	TBBtn Btn(this) ;
	if(startid<0) return(0) ;
	if(BmpType<0 || BmpType>TOOLBAR_TYPE_USER) return(0) ;
	startid=BMPOFFS[BmpType] ;
	return(Btn.Insert(Index,startid+iBitmap,idCommand)) ;
}

UINT  ToolBar::InsertButton(int Index,int iBitmap)
{
	return(InsertButton(Index,CurrentType,iBitmap,-1)) ;
}

void  ToolBar::SetSpacer(int InsIndex)
{
	TBBtn Btn(this) ;
	Btn.Spacer(InsIndex) ;
}

void ToolBar::FitSize(WPARAM wp,LPARAM lp)
{
	SendMessage(WM_SIZE,wp,lp) ;
}

UINT ToolBar::GetButtonID(int Index)
{
	TBBUTTON TBB ;
	if(!SendMessage(TB_GETBUTTON,(WPARAM)Index,(LPARAM)&TBB)) return(0) ;
	return((UINT)TBB.idCommand) ;
}

BOOL ToolBar::IsTBButton(int idCommand)
{
	if(idCommand==0) return(FALSE) ; // SpacerZbgĂTRUEɂȂ
	if(SendMessage(TB_COMMANDTOINDEX,(WPARAM)idCommand,0)==-1) return(FALSE) ;
	return(TRUE) ;
}

int  ToolBar::ToolBarList(UINT *IndexList)
{
	TBBUTTON TBB ;
	int i=0 ;
	while(SendMessage(TB_GETBUTTON,(WPARAM)i,(LPARAM)&TBB)){
	  IndexList[i++]=(UINT)TBB.idCommand ;
	}
	return(i) ;
}
