// --------------------------------------------------------------------
//  Common Controls 

#ifndef _COMMON_CONTROLS_H_
#define _COMMON_CONTROLS_H_
#include <commctrl>

#define STATUSBAR_PARTITION_MAX 32
#define SBW_FLEXIBLE -1

class StatusBar : public BaseWnd{
	private:
	  FrameWnd *ParentWnd ;
	  EventMenuID *MenuMsgID ;
	  int Parts,SBP_Pos ;
	  int PartSize[STATUSBAR_PARTITION_MAX] ;
	  CRate *SizeRate ;
	  BOOL UsingRate,UsingFixedEnd,SBP_PopUp,SBP_Set ;
	protected:
	  void Initalize(FrameWnd *Parent,int PartNumb) ;
	  int  FlexPos(void) ;
	public:
	  STYLE<LONG> Style ;
	  StatusBar(FrameWnd *Parent,HMENU MenuID){
	    MenuMsgID=new EventMenuID(MenuID) ;
	    Initalize(Parent,0) ;
	  } ;
	  StatusBar(FrameWnd *Parent){
	    MenuMsgID=new EventMenuID() ;
	    Initalize(Parent,0) ;
	  } ;
	  StatusBar(FrameWnd *Parent,HMENU MenuID,int PartNumb){
	    MenuMsgID=new EventMenuID(MenuID) ;
	    Initalize(Parent,PartNumb) ;
	  } ;
	  StatusBar(FrameWnd *Parent,int PartNumb){
	    MenuMsgID=new EventMenuID() ;
	    Initalize(Parent,PartNumb) ;
	  }
	  ~StatusBar(){
	    if(UsingRate) delete SizeRate ;
	    delete MenuMsgID ;
	  }
	  HWND Create(void) ;
	  HWND GetHandle(void){ return(BaseWnd::GetHandle()) ;}
	  void DefineWidth(int PartPos,int Width) ;
	  void DefineRate(int PartPos,double wdRate){
	    if(UsingRate){
	      SizeRate->SetRate(PartPos,wdRate) ;
	    }
	  }
	  void UseRate(BOOL endfix){
	    SizeRate=new CRate(Parts) ;
	    UsingRate=TRUE ;
	    UsingFixedEnd=endfix ;
	  }
	  void UseRate(CRate *SzRt,BOOL endfix){
	    SizeRate=SzRt ;
	    UsingRate=TRUE ;
	    UsingFixedEnd=endfix ;
	  }
	  void AutoFit(void){
	    ParentWnd->StatusBarAutoFitting(this) ;
	  }
	  void FitSize(WPARAM wp,LPARAM lp,int PartPos,int *Pos) ;
	  void FitSize(WPARAM wp,LPARAM lp) ;
	  void SetWindowText(char *Message) ;
	  void SBPrintSet(int PartPos,BOOL isPopUp=FALSE){
	    if(PartPos>=0 && PartPos<Parts){
	      SBP_Pos=PartPos ; SBP_PopUp=isPopUp ;
	      SBP_Set=TRUE ;
	    }
	  }
	  void SBPrintf(char *form,...) ;
	  void SetWindowText(int PartPos,char *Message,BOOL isPopUp=FALSE) ;
	  HMENU GetMenuID(void){ return(MenuMsgID->GetID()) ; }
} ;

#define TOOLBAR_TYPE_STD  0
#define TOOLBAR_TYPE_VIEW 1
#define TOOLBAR_TYPE_USER 2

class ToolBar : public BaseWnd{
	private:
	  FrameWnd *ParentWnd ;
	  EventMenuID *MenuMsgID ;
	  int BMPOFFS[5] ;
	  int CurrentType ;
	  UINT CurrentUIDType ;
	protected:
	  void Initalize(FrameWnd *Parent) ;
	public:
	  STYLE<LONG> Style ;
	  ToolBar(FrameWnd *Parent,HMENU MenuID){
	    MenuMsgID=new EventMenuID(MenuID) ;
	    Initalize(Parent) ;
	  } ;
	  ToolBar(FrameWnd *Parent){
	    MenuMsgID=new EventMenuID() ;
	    Initalize(Parent) ;
	  } ;
	  ~ToolBar(){
	    delete MenuMsgID ;
	  }
	  HWND Create(void) ;
	  HWND Create(TBBUTTON *tbb,int bmpnumb,int bmpid,int btnnumb,int bwid,int bhit) ;
	  BOOL LoadBitmap(int BmpType,HINSTANCE hiBmp,UINT nID,int BMNumb) ;
	  void SetBitmapType(int BmpType,UINT nID) ;
	  BOOL LoadBitmap(int BMNumb) ;
	  UINT AddButton(int BmpType,int iBitmap,int idCommand=-1) ;
	  UINT AddButton(int iBitmap) ;
	  UINT InsertButton(int Index,int BmpType,int iBitmap,int idCommand=-1) ;
	  UINT InsertButton(int Index,int iBitmap) ;
	  void SetSpacer(int InsIndex) ;
	  void AutoFit(void){
	    ParentWnd->ToolBarAutoFitting(this) ;
	  }
	  void FitSize(WPARAM wp,LPARAM lp) ;
	  HWND GetHandle(void){ return(BaseWnd::GetHandle()) ;}
	  HMENU GetMenuID(void){ return(MenuMsgID->GetID()) ; }
	  UINT  GetButtonID(int Index) ;
	  BOOL  IsTBButton(int idCommand) ;
	  int   ToolBarList(UINT *IndexList) ;
} ;

#endif
