// --------------------------------------------------------------------
// Windows class Lib for Instruction 
//  Win32API NXCu@c܂Ƃߕ̈
//  FfobÖׁCoOL̊댯L

#ifndef _WIN32_CLIB_H_
#define _WIN32_CLIB_H_

void GetWinLibVersion(char *VerString) ;

#define RATE_MAX_PARTITION 128

class CRate{
	private:
	  double RateTable[RATE_MAX_PARTITION] ;
	  long   Maximum ;
	  int    Partition ;
	  double TotalRate ;
	  void   CalcTotal(void) ;
	  long   GetPartitionValue(int Pos){
	    return((long)((double)Maximum*(RateTable[Pos]/TotalRate))) ;
	  } ;
	  void   PackIntVal(int *Table) ;
	public:
	  CRate(){ SetPartition(RATE_MAX_PARTITION) ; }
	  CRate(int Pnumb){ SetPartition(Pnumb) ; }
	  CRate(int Pnumb,double *tbl){
	    SetPartition(Pnumb) ;
	    SetRate(tbl) ;
	  }
	  CRate(int Pnumb,double *tbl,long max){
	    SetPartition(Pnumb) ;
	    SetRate(tbl) ;
	    SetMax(max) ;
	  }
	  ~CRate(){} ;
	  void SetPartition(int Pnumb){
	    if(Pnumb>0 && Pnumb<=RATE_MAX_PARTITION) Partition=Pnumb ;
	    else Partition=RATE_MAX_PARTITION ;
	  }
	  void SetRate(double *tbl) ;
	  void SetRate(int Pos,double xrate){
	    if(Pos>=0 && Pos<Partition) RateTable[Pos]=xrate ;
	  } ;
	  void SetMax(long max){  Maximum=max ; }
	  long GetVal(int Pos){
	    if(Pos>=0 && Pos<Partition){
	      CalcTotal() ;
	      return GetPartitionValue(Pos) ;
	    }
	    return(0l) ;
	  }
	  void GetVal(int *Table){ CalcTotal() ; PackIntVal(Table) ; }
	  void GetVal(int *Table,long max){
	    SetMax(max) ; CalcTotal() ; PackIntVal(Table) ;
	  }
} ;

template <class TNAME> class STYLE{
	protected:
	  UINT _Style ;
	public:
	  STYLE(){ _Style=0 ; }
	  STYLE(TNAME stl){ _Style=(UINT)stl ; }
	  ~STYLE(){}
	  TNAME GetStyle(void){ return((TNAME)_Style) ; }
	  void SetStyle(TNAME stl){ _Style=(UINT)stl ; }
	  void addStyle(TNAME addstl){ _Style|=addstl ; }
	  void subStyle(TNAME substl){ _Style&=(~substl) ; }
	  TNAME   operator*(void){ return((TNAME)_Style) ; }
	  void operator=(TNAME stl){ _Style=(UINT)stl ; }
	  void operator+=(TNAME addstl){ addStyle(addstl) ; }
	  void operator-=(TNAME substl){ subStyle(substl) ; }
} ;

class WindowClass{
	private:
	  WNDCLASS wc ;
	  char IconName[32] ;
	  char MenuName[32] ;
	  void GetNextClassName(char *) ;
	protected:
	  char ClassName[32] ;
	  HINSTANCE hI ;
	public:
	  STYLE<UINT> Style ;
	  WindowClass(HINSTANCE,WNDPROC,char *) ;
	  WindowClass(HINSTANCE,WNDPROC) ;
	  WindowClass(HINSTANCE,WNDPROC,int) ;
	  virtual ~WindowClass(){} ;
	  void SetIcon(char *) ;
	  void SetMenu(char *) ;
	  void SetBkGround(int) ;
	  void SetAll(WNDCLASS) ;
	  ATOM Regist(void) ;
} ;

#define MENU_ID_BASE 0x7000

class EventMenuID{
	private:
	  HMENU EvMenuID ;
	public:
	  EventMenuID() ;
	  EventMenuID(HMENU MID) ;
	  ~EventMenuID(){} ;
	  HMENU GetID(void){ return EvMenuID ; }
	  HMENU Reserve(int Numb) ;
} ;

class BaseWnd{
	private:
	  int RectWidth(RECT rt){ return(rt.right-rt.left) ; } ;
	  int RectHeight(RECT rt){ return(rt.bottom-rt.top) ; } ;
	protected:
	  HWND handleWnd ;
	  // ėp
	  HWND Create(LPCTSTR lpClassName,
	              LPCTSTR lpWindowName,
	              DWORD dwStyle,
	              int x,int y,int nWidth,int nHeight,
	              HWND hWndParent,
	              HMENU hMenu,
	              HINSTANCE hInstance,
	              LPVOID lpParam){
	    handleWnd=CreateWindow(lpClassName,
	                           lpWindowName,
	                           dwStyle,
	                           x,y,nWidth,nHeight,
	                           hWndParent,
	                           hMenu,
	                           hInstance,
	                           lpParam) ;
	    return(handleWnd) ;
	  } ;
	  HWND Create(LPCTSTR cn,LPCTSTR wn,DWORD st,RECT wx,
	              HWND ph,HMENU hm,HINSTANCE hi,LPVOID lp){
	    return(Create(cn,wn,st,wx.left,wx.top,RectWidth(wx),RectHeight(wx),
	             ph,hm,hi,lp)) ;
	  }
	  // ėp,SystemMetricsg^Cv
	  HWND Create(LPCTSTR cn,LPCTSTR wn,DWORD st,
	              int x,int y,int wd,int ht,HWND hp,HMENU hm,HINSTANCE hi,
	              LPVOID lp,BOOL sw){
	    if(sw) return(Create(cn,wn,st,x,y,
	                    wd+GetSystemMetrics(SM_CXBORDER)*2,
	                    ht+GetSystemMetrics(SM_CYCAPTION)
	                    +GetSystemMetrics(SM_CYMENU)
	                    +GetSystemMetrics(SM_CYBORDER)*2,
	                    hp,hm,hi,lp)) ;
	    else return(Create(cn,wn,st,x,y,wd,ht,hp,hm,hi,lp)) ;
	  } ;
	  HWND Create(HWND hwnd){ handleWnd=hwnd ; return(handleWnd) ; }
	public:
	  BaseWnd(){ handleWnd=NULL ; } ;
	  HWND GetHandle(void){ return handleWnd ; } ;
	  HINSTANCE GetInstance(void){
	    if(handleWnd==NULL) return(NULL) ;
	    return((HINSTANCE)GetWindowLong(handleWnd,GWL_HINSTANCE)) ;
	  } ;
	  BOOL SetWindowText(char *msg){
	    return(::SetWindowText(handleWnd,msg)) ;
	  } ;
	  int  GetWindowText(char *txt,int len){
	    return(::GetWindowText(handleWnd,txt,len)) ;
	  }
	  BOOL EnableWindow(BOOL sw){
	    return(::EnableWindow(handleWnd,sw)) ;
	  } ;
	  BOOL PostMessage(UINT msg,WPARAM wp,LPARAM lp){
	    return(::PostMessage(handleWnd,msg,wp,lp)) ;
	  } ;
	  LRESULT SendMessage(UINT msg,WPARAM wp,LPARAM lp){
	    return(::SendMessage(handleWnd,msg,wp,lp)) ;
	  } ;
	  UINT SetTimer(UINT Event,UINT TimeUp){
	    return(::SetTimer(handleWnd,Event,TimeUp,0)) ;
	  } ;
	  BOOL KillTimer(UINT Event){
	    return(::KillTimer(handleWnd,Event)) ;
	  } ;
	  virtual void FitSize(WPARAM,LPARAM){} ;
	  virtual ~BaseWnd(){} ;
} ;

// --------------------------------------------------------------------
//  WindowTimer(SetTimer)

typedef struct _TIMER_FUNC_{
	UINT TimerID ;
	BOOL OneShot ;
	BOOL Regist ;
}TIMERFUNC ;

#define AUTOTIMER_MAX 64

class WindowTimer{
	private:
	  BaseWnd *RefBaseWnd ; // FrameWnd̊{NX̌`ŖႤC
	                        // QƗpȂ̂ŁAKv͖
	  BOOL ExsBaseWnd ;
	  UINT TID_DEFAULT ;
	protected:
	  TIMERFUNC TmSet[AUTOTIMER_MAX] ;
	  void Initalize(void) ;
	  UINT GetNewEventID(void) ;
	  int  GetTimerNumb(UINT TimerID) ;
	  UINT RegistTimer(BOOL OneShot) ;
	  BOOL UnRegTimer(UINT TimerID) ;
	  BOOL IsOneShot(UINT TimerID) ;
	  BOOL IsExists(UINT TimerID) ;
	public:
	  WindowTimer() ;
	  virtual ~WindowTimer() ;
	  void RegisterBaseWnd(BaseWnd *ref){
	    RefBaseWnd=ref ;
	    ExsBaseWnd=TRUE ;
	  } ;
	  UINT SetTimer(UINT TimeUp,BOOL OneShot) ; // TimerEventID́A擾
	  BOOL KillTimer(UINT TimerID) ;
	  BOOL KillAll(void) ; // WindowTimerǗ̃^C}Sď
	  virtual void TimeUp(HWND,WPARAM){} ; // [Ugp
	  void WindowTimerTimeUp(HWND hwnd,WPARAM wp,LPARAM){
	  // FrameWndWndProcĂ΂
	    if(IsOneShot((UINT)wp)) KillTimer((UINT)wp) ; // OneShotȂ΁A^C}~
	    TimeUp(hwnd,wp) ;// [U`[`Ă
	  }
} ;

class FrameWnd : public WindowClass,public BaseWnd{
	private:
	  LPVOID    lParam ;
	  BOOL      TimerClassRegist ;
	  WindowTimer *WTimer ;
	  char MBTitle[256] ;
	  UINT MBType ;
	  void DefaultSetUp(void) ;
	  BaseWnd *TBWnd,*SBWnd ; // ToolBar,StatusBarI[gtBbeBOp
	  BOOL TBAutoFitting,SBAutoFitting,ChildWnd ;
	  HWND ParentHnd ;
	  HMENU MenuID ;
	protected:
	  BaseWnd *ParentWnd ; // CHILDp
	public:
	  STYLE<DWORD> Style ;
	  FrameWnd(HINSTANCE,WNDPROC) ;
	  FrameWnd(HINSTANCE) ;    // WndProcw肵Ȃqǉ
	  FrameWnd(BaseWnd *Parent) ; // qEChEƂĎgpꍇ
	  virtual ~FrameWnd(){  // ͖ܘ_virtual
	    if(TimerClassRegist) delete WTimer ;
	  } ;
	  void SetLParam(LPVOID) ;
	  HWND Create(char *,int,int,int,int,BOOL) ;
	  HWND Create(char *,int,int,int,int) ;
	  HWND Create(char *,RECT) ;
	  HWND Create(char *,int,int) ;
	  HWND Create(char *,int,int,BOOL) ;
	  HWND Create(char *) ;
// ---- ^C}֘A
	  void UseTimer(WindowTimer *TmrCls){
	    WTimer=TmrCls ;
	    TimerClassRegist=TRUE ;
	    WTimer->RegisterBaseWnd(this) ;
	  } ;
	  // WindowTimer classgꍇ́AʂāAo^ƍ폜sB
	  UINT SetTimer(UINT TimeUp,BOOL OneShot){
	    if(TimerClassRegist) return WTimer->SetTimer(TimeUp,OneShot) ;
	    else return(0) ;
	  } ;
	  BOOL KillTimer(UINT TimerID){
	    if(TimerClassRegist) return WTimer->KillTimer(TimerID) ;
	    else return(FALSE) ;
	  } ;
	  BOOL KillAllTimer(void){
	    if(TimerClassRegist) return WTimer->KillAll() ;
	    else return(FALSE) ;
	  } ;
//
	  void Show(int) ;
	  HWND GetHandle(void){ return(handleWnd) ; } ;
	  virtual WPARAM MessageLoop(void) ;
	  //  MessageBoxւ̃T|[g
	  int MessageBox(char *msg,char *captn,UINT typ) ;
	  int MessageBox(char *msg){ return(MessageBox(msg,MBTitle,MBType)) ; }
	  int MessageBoxf(char *form,...) ;
	  void SetMBTitle(char *title){ strcpy(MBTitle,title) ; } ;
	  void SetMBType(UINT type){ MBType=type ; } ;
	  // StatusBar,ToolBar̃I[gtBbeBO
	  void StatusBarAutoFitting(BaseWnd *SB){
	    SBWnd=SB ; SBAutoFitting=TRUE ;
	  }
	  void ToolBarAutoFitting(BaseWnd *TB){
	    TBWnd=TB ; TBAutoFitting=TRUE ;
	  }
	  // ̃NX̃vV[W
	  virtual LRESULT WindowProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam) ;
	  virtual void OnCreate(HWND){} ;
	  virtual void OnDestroy(HWND){ KillAllTimer() ; PostQuitMessage(0) ; } ;
	  virtual void OnSize(HWND,WPARAM wp,LPARAM lp){
	    if(SBAutoFitting) SBWnd->FitSize(wp,lp) ;
	    if(TBAutoFitting) TBWnd->FitSize(wp,lp) ;
	  } ;
	  virtual void OnPaint(HWND,HDC){} ;
	  virtual void OnTimer(HWND,WPARAM,LPARAM){} ;
	  virtual void OnCommand(HWND,WPARAM,LPARAM){} ;
	  virtual void OnUser(HWND,WPARAM,LPARAM){} ;
	  virtual LRESULT OnOtherMessage(HWND hwnd,UINT msg,WPARAM wp,LPARAM lp){
	    return(DefWindowProc(hwnd,msg,wp,lp)) ;
	  } ;
	  FrameWnd *GetThis(void){ return(this) ; } ;
} ;

class FrameWndApp{
	protected:
	  FrameWnd *MainWnd ;
	  WPARAM RetV ;
	public:
	  FrameWndApp(FrameWnd *fw){ MainWnd=fw ; } ;
	  FrameWndApp(HINSTANCE hi){ MainWnd=new FrameWnd(hi) ; } ;
	  virtual ~FrameWndApp(){ delete MainWnd ; } ;
	  virtual void SetWndClass(void){} ;
	  virtual void CreateAll(void){} ;
	  WPARAM WorkMain(int ComShow){
	    SetWndClass() ;
	    MainWnd->Regist() ;
	    CreateAll() ;
	    MainWnd->Show(ComShow) ;
	    RetV=MainWnd->MessageLoop() ;
	    return(RetV) ;
	  }
} ;

class FrameWndChild{
	protected:
	  FrameWnd *ChildWnd ;
	  WPARAM RetV ;
	public:
	  FrameWndApp(FrameWnd *fw){ ChildWnd=fw ; } ;
	  FrameWndApp(HINSTANCE hi){ ChildWnd=new FrameWnd(hi) ; } ;
	  virtual ~FrameWndApp(){ delete ChildWnd ; } ;
	  virtual void SetWndClass(void){} ;
	  virtual void CreateAll(void){} ;
	  WPARAM WorkMain(int ComShow){
	    SetWndClass() ;
	    ChildWnd->Regist() ;
	    CreateAll() ;
	    MainWnd->Show(ComShow) ;
	    RetV=MainWnd->MessageLoop() ;
	    return(RetV) ;
	  }
} ;

class PushBtn : public BaseWnd{
	protected:
	  FrameWnd  *ParentWnd ;
	  EventMenuID *MenuMsgID ;
	public:
	  STYLE<DWORD> Style ;
	  PushBtn(FrameWnd *Parent,HMENU MenuID){
	    ParentWnd=Parent ;
	       // ̎_ł́Anhm肵ĂȂ\̂ŁA
	       // nhƁACX^X̎擾͍sȂB
	       // iCreate鎞_ł́AŒłenh
	       // m肵Ă̂ŁAeNXƂĕێACreateOGetB
	    MenuMsgID=new EventMenuID(MenuID) ;
	    Style=BS_PUSHBUTTON|WS_CHILD|WS_VISIBLE ; // {X^C
	    handleWnd=NULL ;
	  }
	  PushBtn(FrameWnd *Parent){ // menuid擾^Cv
	    ParentWnd=Parent ;
	    MenuMsgID=new EventMenuID() ;
	    Style=BS_PUSHBUTTON|WS_CHILD|WS_VISIBLE ; // {X^C
	    handleWnd=NULL ;
	  }
	  ~PushBtn(){ delete MenuMsgID ; } ;
	  HWND Create(char *title,int sx,int sy,int wd,int ht){
	    if(ParentWnd->GetHandle()==NULL) return(NULL) ;
	    return(BaseWnd::Create("BUTTON",title,*Style,sx,sy,wd,ht,
	                      ParentWnd->GetHandle(),MenuMsgID->GetID(),
	                      ParentWnd->GetInstance(),NULL)) ;
	  } ;
	  HWND Create(char *title,RECT wx){
	    if(ParentWnd->GetHandle()==NULL) return(NULL) ;
	    return(BaseWnd::Create("BUTTON",title,*Style,wx,
	                      ParentWnd->GetHandle(),MenuMsgID->GetID(),
	                      ParentWnd->GetInstance(),NULL)) ;
	  } ;
	  HWND GetHandle(void){ return(handleWnd) ; } ;
	  HMENU GetMenuID(void){ return(MenuMsgID->GetID()) ; }
} ;

class Label : public BaseWnd{
	protected:
	  FrameWnd  *ParentWnd ;
	  EventMenuID *MenuMsgID ;
	public:
	  STYLE<DWORD> Style ;
	  Label(FrameWnd *Parent,HMENU MenuID){
	    ParentWnd=Parent ;
	    MenuMsgID=new EventMenuID(MenuID) ;
	    Style=SS_LEFT|WS_CHILD|WS_VISIBLE|WS_BORDER ; // {X^C
	    handleWnd=NULL ;
	  }
	  Label(FrameWnd *Parent){
	    ParentWnd=Parent ;
	    MenuMsgID=new EventMenuID() ;
	    Style=SS_LEFT|WS_CHILD|WS_VISIBLE|WS_BORDER ; // {X^C
	    handleWnd=NULL ;
	  }
	  ~Label(){ delete MenuMsgID ;} ;
	  HWND Create(char *title,int sx,int sy,int wd,int ht){
	    if(ParentWnd->GetHandle()==NULL) return(NULL) ;
	    return(BaseWnd::Create("STATIC",title,*Style,sx,sy,wd,ht,
	                      ParentWnd->GetHandle(),MenuMsgID->GetID(),
	                      ParentWnd->GetInstance(),NULL)) ;
	  } ;
	  HWND Create(char *title,RECT wx){
	    if(ParentWnd->GetHandle()==NULL) return(NULL) ;
	    return(BaseWnd::Create("STATIC",title,*Style,wx,
	                      ParentWnd->GetHandle(),MenuMsgID->GetID(),
	                      ParentWnd->GetInstance(),NULL)) ;
	  } ;
	  HWND GetHandle(void){ return(handleWnd) ; } ;
	  HMENU GetMenuID(void){ return(MenuMsgID->GetID()) ; }
} ;

class Thread{
	protected:
	  HANDLE ThreadHandle ;
	  DWORD  Result ;
	  LPVOID ThVal ;
	  BOOL   ValExist ;
	  BOOL IsExists(void){
	    if(ThreadHandle!=NULL) return(TRUE) ;
	    else return(FALSE) ;
	  } ;
	public:
	  Thread(){ ThreadHandle=NULL ; ValExist=FALSE ; } ;
	  virtual ~Thread(){ if(IsExists()) Terminate() ; } ;
	  HANDLE Create(LPVOID tv) ;
	  HANDLE Create(void) ;
	  DWORD  Suspend(void) ;
	  DWORD  Resume(void) ;
	  BOOL  Terminate(void) ;
	  virtual DWORD ThreadFunc(LPVOID){ return 0 ; } ;
	  virtual DWORD ThreadFunc(void){ return 0 ; } ;
	  DWORD ThreadStartRoutine(void) ;
	  DWORD  GetResult(void){ return Result ; }
	  HANDLE GetHandle(void){ return ThreadHandle ; } ;
} ;

class Runnable{
	private:
	  Thread *Runner ;
	public:
	  Runnable(Thread* thcls){ Runner=thcls ; }
	  ~Runnable(){ delete Runner ; }
	  HANDLE Run(void){ return Runner->Create() ; }
	  HANDLE Run(LPVOID Rv){ return Runner->Create(Rv) ; }
	  DWORD  Pause(void){ return Runner->Suspend() ; }
	  DWORD  Resume(void){ return Runner->Resume() ; }
	  BOOL   Stop(void){ return Runner->Terminate() ; }
	  DWORD  Result(void){ return Runner->GetResult() ; }
	  HANDLE Handle(void){ return Runner->GetHandle() ; }
} ;
#endif
